#!/bin/bash
declare g_curPath
declare exp_tool
declare scp_tool
declare ip_file
declare type
declare patch_bin="Sudo_Vulnerability_20210330"
g_password=''
function get_cur_path()
{
    cd "$(dirname "${BASH_SOURCE-$0}")"
    g_curPath="${PWD}"
    cd "${g_curPath}"
}

function trim() 
{
    local var="$*"
    # remove leading whitespace characters
    var="${var#"${var%%[![:space:]]*}"}"
    # remove trailing whitespace characters
    var="${var%"${var##*[![:space:]]}"}"   
    echo -n "$var"
}

function read_parameter()
{
    local msgTip="Please enter root password:"
    local ishow="${1}"
    local value=""

    if [ "${ishow}" = "hidden" ]; then
        read -t 60 -r -s -p "$msgTip"
    else
        read -t 60 -r  -p "$msgTip"
    fi
    
    if [ -n "$REPLY" ]; then
        value="${REPLY}"
    else
        value=""
    fi

    g_password="$(trim "${value}")"
}

init_param()
{
    ip_file=${g_curPath}/ips.ini
    exp_tool=${g_curPath}/ssh-util.exp
    scp_tool=${g_curPath}/scp-util.exp
    type="${1}"
    
    if [ "${type}" != "install" -a "${type}" != "uninstall" ]; then
        echo  "$1 is not install or uninstall, please check it."
        exit 1
    fi

    while read line;
    do
        if [ -z "${line}" ]; then
            continue
        fi
        
        if ! ping -c 1 -W 5 "${line}" >/dev/null
        then
            echo "the node (${line}) is dead, or network delay is high, please check it."
            exit 1
        fi
    done < ${ip_file}
    
    read_parameter "hidden"
    
}

scp_remote()
{
    echo  "start to scp script to remote."

    if [ -f "${g_curPath}/scpmark" ]; then
        echo  "already make scp skip it."
        return 0
    fi
    
    local localIp=$(hostname -i)

    local ip_arr=$(cat "${ip_file}")
    for ip_value in ${ip_arr}
    do
        if [ -z "${ip_value}" ]; then
            continue
        fi
        
        if [ "${ip_value}" = "${localIp}" ]; then
            cp -rf "${g_curPath}/${patch_bin}/" "/root/"
            continue
        fi
        
        ${scp_tool} "${g_curPath}/${patch_bin}/" ${ip_value} "root" "${g_password}" "/root/"
        if [ $? -ne 0 ]; then
            echo "scp ${g_curPath}/${patch_bin} ${ip_value}:/root failed,Maybe the password is incorrect. Please check the password and try again after 5 minutes."
            return 1
        fi
        
    done
    
    touch "${g_curPath}/scpmark"
    
    echo "end to scp files."
}

execute_script()
{
    #加一个空行，防止最后一行读不到
    echo >> ${ip_file}
    local localIp=$(hostname -i)
    local command="sh /root/${patch_bin}/sudo_repair.sh ${type}"
    
    while read line;
    do
        line=$(trim ${line})
        [ -z ${line} ] && continue
        if [ "${line}" = "${localIp}" ]; then
            sh /root/${patch_bin}/sudo_repair.sh "${type}"
            continue
        fi
        ${exp_tool} "${line}" "root" "${g_password}" "60" "sh /root/${patch_bin}/sudo_repair.sh ${type}"  "22"
        if [ $? -eq 4 ];then
            echo "The password does not match. Please check. Please wait five minutes and try again."
            return 1
        fi
    
    done < ${ip_file} 
}

main()
{
    #初始化参数
    init_param "$@"
    
    #先将脚本scp到每个节点
    scp_remote
    if [ $? -ne 0 ]; then
        return 1
    fi
    execute_script
    
}

get_cur_path
main "$@"